>module Main where
>import ChaseImports
>import UserRules (userRules)
>import StandardRules (Tag,Rule,standardRules)
>import UserRulesXML (userRulesXML)
>import RuleUtils (commentLine,texts)
>import PreludData(preludeData)
>import DataP
>import Pretty 
>import List (partition)
>import System

>main = do	
>       l <- getArgs
>	putStrLn "{-% DrIFT (Automatic class derivations for Haskell) %-}"
>	putStrLn "{-%       version 1.7 for Strafunski                %-}"
>	derive l

>--derive l = case l of		
>--   [f] -> derive' f
>--    _	 -> error "Incorrect number of Args."
>derive l
>  = derive' (parseOptions l)
>  where
>    derive' (OptionsDrIFT fname resultsOnly globalTags _) = do
>	file <- readFile fname
>       let (body,_) = userCode file
>           b = isLiterate body
>	    (docs,dats,todo) = process . (addGlobals globalTags)
>                                      . parser . fromLit b $ body
>	moreDocs <- fmap ((\(x,_,_) -> x) . process) 
>                        (chaseImports body todo)
>	let result = toLit b . (\r -> codeSeperator ++ '\n':r) . 
>			render . vsep $ (docs ++ sepDoc:moreDocs)
>  --	writeFile (backup fname) file
>  --   writeFile (newfile fname) (body ++ result)
>       putStrLn (if resultsOnly then result else (body ++ result))

>rules = userRules ++ userRulesXML ++ standardRules
>-- codeRender doc = fullRender PageMode 80 1 doc ""  -- now obsolete.
>vsep = vcat . map ($$ (text ""))
>sepDoc = commentLine . text $ " Imported from other files :-"

>backup :: FilePath -> FilePath
>backup f = (reverse . dropWhile (/= '.') . reverse ) f ++ "bak"

>newfile :: FilePath -> FilePath
>newfile f = (reverse . dropWhile (/= '.') . reverse ) f ++ "DrIFT"

Main Pass - Takes parsed data and rules and combines to create instances...
Returns all parsed data, ande commands calling for files to be imported if
datatypes aren't located in this module.

>process :: ToDo -> ([Doc],[Data],ToDo)
>process i = (concatMap g dats ++ concatMap h moreDats,parsedData,imports)
>       where
>	g (tags,d) = [(find t rules) d | t <- (tags ++ directives)]
>	h (tags,d) = [(find t rules) d | t <- tags]
>	directives = concatMap fst globals
>	(dats,commands) = partition (isData . snd) i
>	(globals,fors) = partition (\(_,d) -> d == Directive) commands
>	(moreDats,imports) = resolve parsedData fors ([],[])
>	parsedData = map snd dats ++ preludeData

>find :: Tag -> [Rule] -> (Data -> Doc)
>find t r = case filter ((==t) . fst) $ r of
>               [] -> const (commentLine warning)
>               (x:xs) -> snd x
>   where
>   warning = hsep . texts $ ["Warning : Rule",t,"not found."]                 

Added by Joost Visser:

>data OptionsDrIFT
>  = OptionsDrIFT { fin :: String, 
>                   resultsOnly :: Bool,
>                   globalTags :: [Tag],
>                   searchPath :: [String] }
>defaultOptionsDrIFT
>  = OptionsDrIFT { fin = error $ "No filename specified\n"++usage, 
>                   resultsOnly = False,
>                   globalTags = [],
>                   searchPath = ["."] }
>
>parseOptions args
>  = p args
>    where 
>      p []		  = defaultOptionsDrIFT
>      p ("-r":args)      = (p args){ resultsOnly = True }
>      p ("-g":tag:args)  = addGlobalTag tag (p args)
>      p ("-P":path:args) = extendPath path (p args)
>      p (fname:args)	  = (p args){ fin = fname }
>      p args		  = err $ "Can't parse options: "++concat args
>      err msg		  = error $ msg++"\n"++usage
>      addGlobalTag t o   = o{ globalTags = t:(globalTags o) }
>      extendPath p o     = o{ searchPath = (splitPath p (searchPath o)) }
>
>usage
> = unlines $ ["Usage","",
>             "  DrIFT [-r] <fname>",
>             "",
> 	      "Options","",
>	      "  <fname>       name of input file",
>	      "  -r            print generated instances only",
>             "  -g <class>    generate instances of class for all datatypes",
>             "  -P <path>     directories to search for input",
>	      "",
>	      "By default, the output consists of the contents of the",
>	      "input file, with the generated instances appended. With",
>	      "the -r option, the contents of the input file is not",
>	      "printed; only the generated instances are.",
>             "",
>             "Instead of putting the directive {-! global : C !-} in the",
>             "input file, you can specify -g C on the command line.",
>             "",
>             "The following rules are currently supported:"
>	     ] ++
>	     (fmt 60 "" (map fst rules))

>fmt i l []			= [l]
>fmt i l (w:ws) 
>	| (length lw) <= i	= fmt i lw ws
>       | otherwise             = (l:fmt i "" (w:ws))
>       where lw = l++(' ':w) 

>addToDo 		:: [Tag] -> ToDo -> ToDo
>addToDo tags tds	=  map (\(ts,d) -> (tags++ts,d)) tds

>addGlobals		:: [Tag] -> ToDo -> ToDo
>addGlobals tags tds	=  (tags,Directive):tds

>splitPath p ds			=  splitPath' (span (/=':') p) ds
>splitPath' ("",[]) ds		=  []
>splitPath' ("",(':':etc)) ds 	=  ds++(splitPath etc ds)  
>splitPath' (d,[]) ds		=  [d]
>splitPath' (d,(':':[])) ds	=  d:ds
>splitPath' (d,(':':etc)) ds	=  d:(splitPath etc ds)
