module HsLiteral where

-- import Ratio
--import PrettyPrint
import SrcLoc

data HsLiteral
    = HsInt SrcLoc  Integer
    | HsChar        Char
    | HsString      String
    | HsFrac SrcLoc Rational
    -- GHC unboxed literals:
    | HsCharPrim    Char
    | HsStringPrim  String
    | HsIntPrim     Integer
    | HsFloatPrim   Rational
    | HsDoublePrim  Rational
    -- GHC extension:
    | HsLitLit      String
      deriving (Show)

instance Eq HsLiteral where 
  HsInt _ i1      == HsInt _ i2      = i1 == i2
  HsChar  i1      == HsChar  i2      = i1 == i2
  HsString i1     == HsString i2     = i1 == i2 
  HsFrac _ i1     == HsFrac _ i2     = i1 == i2
  HsCharPrim i1   == HsCharPrim i2   = i1 == i2
  HsStringPrim i1 == HsStringPrim i2 = i1 == i2
  HsIntPrim  i1   == HsIntPrim  i2   = i1 == i2 
  HsFloatPrim i1  == HsFloatPrim i2  = i1 == i2
  HsDoublePrim i1 == HsDoublePrim i2 = i1 == i2 
  HsLitLit     i1 == HsLitLit i2     = i1 == i2