
module RefacSwapArgs(swapArgs) where

import RefacUtils 

swapArgs args  
 = do let fileName =args !! 0  
          pos = (read (args!!1), read (args!!2))::(Int,Int)   
      (_, exps, mod, toks)<-parseSourceFile fileName         
      let pnt =locToPNT fileName pos  mod                                     
          pn  = pNTtoPN pnt                   
      if isFunName pn mod  
       then do refactoredMod<-applyRefac (doSwap pn) (Just (mod, toks)) fileName 
               if isExported pnt exps
                  then  do refactoredClients <- applyRefacToClientMods (doSwap pn) fileName
                           writeRefactoredFiles False $ refactoredMod:refactoredClients      
                 else  writeRefactoredFiles False [refactoredMod]
       else error "\nInvalid cursor position!" 

doSwap pn = applyTP (full_buTP (idTP `adhocTP` inMatch     -- handle the formal parameters.    
                                     `adhocTP` inExp       -- handle the actual parameters.
                                     `adhocTP` inDecls ))  -- handle the type signatures.
  where 
    inMatch ((HsMatch loc fun pats rhs ds)::HsMatchP)
      | pNTtoPN fun == pn  
      = case pats of   
         (p1:p2:ps) -> do pats'<-swap p1 p2 pats  
                          return (HsMatch loc fun pats' rhs ds)
         _          -> error "Insufficient arguments to swap." 
    inMatch m = return m  

    inExp exp@((Exp (HsApp (Exp (HsApp e e1)) e2))::HsExpP)
      | expToPN e == pn    
      = swap e1 e2 exp     
    inExp e = return e 

    inDecls (decls::[HsDeclP]) 
      = case break (definesTypeSig pn) decls         
        of (_ , [])   -> return decls
           (b, t:ts)  -> do newSig <- swapInSig' [t]   
                            return (b ++ newSig ++ ts)
      where 

       swapInSig' sig@[(Dec (HsTypeSig loc is c tp))]
        = let ts = tyFunToList tp
          in  if length is == 1   
               then swap (ts!!0) (ts!!1) sig                           
               else do tp' <- swap (ts!!0) (ts!!1) tp                            
                       let newSig = [Dec (HsTypeSig loc (filter (\x->pNTtoPN x==pn) is) c tp'),  
                                     Dec (HsTypeSig loc (filter (\x->pNTtoPN x/=pn) is) c tp)]
                       update sig newSig sig
  
       tyFunToList (Typ (HsTyFun t1 t2)) = t1:(tyFunToList t2)
       tyFunToList t = [t]


