module TiError where
import PrettyPrint(Printable(..),($$),(<>),(<+>),fsep,nest,modn)
import SrcLoc
import SrcLocPretty
import HsName(ModuleName)

data Error i
  = InContext (ErrorContext i) (Error i)
  | Other String
  deriving Show

data ErrorContext i
  = AtPos SrcLoc String
  | DeclCtx [i]
  | ModuleCtx [ModuleName]
  | OtherCtx String
  deriving Show

instance Printable i => Printable (Error i) where
  ppi (InContext ctx e) = ctx<>":" $$ nest 2 e
  ppi (Other msg) = ppi msg

instance Printable i => Printable (ErrorContext i) where
  ppi (AtPos loc "") = ppi loc
  ppi (AtPos loc msg) = ppi loc<>":"<+>msg
  ppi (DeclCtx is) = "In the declaration of"<+>fsep is
  ppi (ModuleCtx [m]) = "In module"<+>modn m
  ppi (ModuleCtx ms) = "In modules"<+>fsep (map modn ms)
  ppi (OtherCtx msg) = ppi msg
