module PropPosSyntax(module PropPosSyntax,module PosName,module Hs,SN) where
import PropSyntax as Hs hiding (ModuleName,HsName,Id{-,HsIdent,HsField(),HsImportDecl(),HsConDecl(),HsExportSpec,HsImportSpec-},hsTyTuple)
import qualified PropSyntax as Hs
import HsConstants as Hs(main_mod,tuple,mod_Prelude)
import qualified HsConstants as Hs
--import PrettyPrint
import SourceNames
import PosName
import SpecialNames as Hs
import QualNames(isQual)
--import Entity()

pos i p = SN i p

type HsExp = HsExpI HsName
type HsPat = HsPatI HsName
type HsDecl = HsDeclI HsName
type HsType = HsTypeI HsName

type HsQualType = HsQualTypeI HsName
type Assertion = AssertionI HsName
type Predicate = PredicateI HsName


type HsField = Hs.HsFieldI HsName
type HsImportDecl = Hs.HsImportDeclI ModuleName HsName
type HsConDecl = Hs.HsConDeclI HsName
type HsExportSpec = Hs.HsExportSpecI ModuleName HsName
type HsImportSpec = Hs.HsImportSpecI HsName
type HsModuleR = Hs.HsModuleI ModuleName HsName [HsDecl]

qualid (p,s) = pos (splitQualName (srcFile p) s) p

unqualid (p,s) = pos (Hs.UnQual s) p

qualify m n = pos (Hs.Qual m n)

minus_name = pos Hs.minus_name
pling_name = pos Hs.pling_name
period_name = pos Hs.period_name
as_name = pos Hs.as_name
qualified_name = pos Hs.qualified_name
hiding_name = pos Hs.hiding_name
foreign_name p = unqualid (p,"foreign")

unit_tycon_name = pos Hs.unit_tycon_name
--list_tycon_name = pos Hs.list_tycon_name
--fun_tycon_name = pos Hs.fun_tycon_name
--tuple_tycon_name arity = pos (Hs.tuple_tycon_name arity)

list_tycon = Hs.hsTyCon . list_tycon_name :: Hs.SrcLoc -> HsType
tuple_tycon n = hsTyCon . tuple_tycon_name n :: SrcLoc -> HsType

hsTyTuple p ts = foldl hsTyApp (tuple_tycon (length ts-1) p) ts

isQualified = isQual :: HsName -> Bool

-- An omitted module header is equivalent to module Main(main) where ...
hsMainModule loc body =
    hsModule loc (pos (main_mod (srcFile loc)) loc)
             (Just [exportVar (main_name loc)]) body
main_name = pos Hs.main_name
